Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Tue Oct 11 12:34:38 2011
FILE NAME: radiation_simple.f90
PROGRAM NAME: radiation_simple
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

    94  vec  (   3): Unvectorized loop.
    96  vec  (   4): Vectorized array expression.
    96  vec  (   4): Vectorized array expression.
    98  vec  (   4): Vectorized array expression.
    98  vec  (   4): Vectorized array expression.
   100  vec  (   4): Vectorized array expression.
   100  vec  (   4): Vectorized array expression.
   111  vec  (   3): Unvectorized loop.
   113  vec  (   4): Vectorized array expression.
   113  vec  (   4): Vectorized array expression.
   116  vec  (   4): Vectorized array expression.
   116  vec  (   4): Vectorized array expression.
   121  vec  (   4): Vectorized array expression.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Tue Oct 11 12:34:38 2011
FILE NAME: radiation_simple.f90
PROGRAM NAME: radiation_simple
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != Module Radiation
     2  !
     3  ! Authors::   SUGIYAMA Ko-ichiro
     4  ! Version::   $Id: radiation_simple.f90,v 1.4 2011-07-15 08:43:29 sugiyama Exp $
     5  ! Tag Name::  $Name: arare5-20111010 $
     6  ! Copyright:: Copyright (C) GFD Dennou Club, 2006. All rights reserved.
     7  ! License::   See COPYRIGHT[link:../../COPYRIGHT]
     8  !
     9  !== Overview
    10  !
    11  !ǥͲ׻뤿Υѥå⥸塼
    12  !Ūˤϰʲι׻뤿δؿǼ.
    13  !  * 
    14  !
    15  !== Error Handling
    16  !
    17  !== Bugs
    18  !
    19  !== Note
    20  !
    21  !
    22  !== Future Plans
    23  !
    24  !
    25  
    26  module Radiation_Simple
    27    !
    28    !ǥͲ׻뤿Υѥå⥸塼
    29    !Ūˤϰʲι׻뤿δؿǼ.
    30    !  * 
    31    !
    32  
    33    !⥸塼ɤ߹
    34    use dc_types, only: DP, STRING
    35    use dc_iounit,  only: FileOpen
    36    use dc_message, only: MessageNotify
    37    use gtool_historyauto, only: HistoryAutoAddVariable
    38  
    39    use mpi_wrapper,only: myrank
    40    use gridSet,  only: imin,     & !x β
    41      &                 imax,     & !x ξ
    42      &                 jmin,     & !y β
    43      &                 jmax,     & !y ξ
    44      &                 kmin,     & !z β
    45      &                 kmax        !z ξ
    46    use axesset,  only: z_Z         !Z ɸ(顼ʻ)
    47    use constants,only: DayTime     ! 1 Ĺ [s]
    48    use basicset, only: xyz_ExnerBZ !ʡؿδܾ
    49    use namelist_util, only: namelist_filename
    50  
    51    !ۤηػ
    52    implicit none
    53  
    54    !private °
    55    private
    56  
    57    !ѿ
    58    real(DP), save, allocatable, public :: xyz_RadHeatVary(:,:,:)   !ͲǮ¸ߤΰ
    59    real(DP), save, allocatable, public :: xyz_RadHeatConst(:,:,:)  !ͲǮ¸ߤΰ
    60  
    61    public Radiation_Simple_init
    62  
    63  contains
    64  
    65  !!!------------------------------------------------------------------------!!!
    66    subroutine Radiation_Simple_init
    67      !
    68      !NAMELIST Ͷ
    69      !
    70  
    71      !ۤηػ
    72      implicit none
    73  
    74      !ѿ
    75      real(DP)                 :: HeightUp   = 0.0d0  !ͶͿľΰξ
    76      real(DP)                 :: HeightDown = 0.0d0  !ͶͿľΰβ
    77      real(DP)                 :: RadHeatRate = 0.0d0   !ͲǮΨ [K/day]
    78      integer                  :: k                      !롼ѿ
    79      integer                  :: unit
    80  
    81      ! NAMELIST 
    82      NAMELIST /radiation_simple_nml/ RadHeatRate, HeightUp, HeightDown
    83  
    84      call FileOpen(unit, file=namelist_filename, mode='r')
    85      read(unit, NML=radiation_simple_nml)
    86      close(unit)
    87  
    88      allocate( xyz_RadHeatVary(imin:imax, jmin:jmax, kmin:kmax) )
    89      allocate( xyz_RadHeatConst(imin:imax, jmin:jmax, kmin:kmax) )
    90  
    91  
    92      ! ̤Ͷ.
    93      ! ɽ̤ RadHeight ǻꤵ줿٤ޤǤδ֤ǰѤͿ.
    94      do k = kmin, kmax
    95        if ( z_Z(k) <= HeightDown  ) then
    96          xyz_RadHeatConst(:,:,k) = 0.0d0
     .        if (t2 - t3 + 1 .gt. 0) then                                      
     .           J1 = and(t2 - t3 + 1,3)                                        
     .  !CDIR    NODEP                                                          
     .           do t277 = 1, J1                                                
     .  !CDIR       NODEP                                                       
     .              do t279 = 1, 2 + t0 - t1 - min0(1,t0 - t1 + 1)              
     .                 xyz_radheatconst(t1+t279-1,t277-1+t3,k) =                
     .       1            0.0000000000000000e+000                               
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t277 = J1 + 1, t2 - t3 + 1, 4                               
     .  !CDIR       NODEP                                                       
     .              do t279 = 1, 2 + t0 - t1 - min0(1,t0 - t1 + 1)              
     .                 xyz_radheatconst(t1+t279-1,t277-1+t3,k) =                
     .       1            0.0000000000000000e+000                               
     .                 xyz_radheatconst(t1+t279-1,t277+t3,k) =                  
     .       1            0.0000000000000000e+000                               
     .                 xyz_radheatconst(t1+t279-1,t277+1+t3,k) =                
     .       1            0.0000000000000000e+000                               
     .                 xyz_radheatconst(t1+t279-1,t277+2+t3,k) =                
     .       1            0.0000000000000000e+000                               
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
     .        go to 10010                                                       
    97        elseif( z_Z(k) >= HeightUp ) then
    98          xyz_RadHeatConst(:,:,k) = 0.0d0
     .        if (t2 - t3 + 1 .gt. 0) then                                      
     .           J2 = and(t2 - t3 + 1,3)                                        
     .  !CDIR    NODEP                                                          
     .           do t271 = 1, J2                                                
     .  !CDIR       NODEP                                                       
     .              do t273 = 1, 2 + t0 - t1 - min0(1,t0 - t1 + 1)              
     .                 xyz_radheatconst(t1+t273-1,t271-1+t3,k) =                
     .       1            0.0000000000000000e+000                               
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t271 = J2 + 1, t2 - t3 + 1, 4                               
     .  !CDIR       NODEP                                                       
     .              do t273 = 1, 2 + t0 - t1 - min0(1,t0 - t1 + 1)              
     .                 xyz_radheatconst(t1+t273-1,t271-1+t3,k) =                
     .       1            0.0000000000000000e+000                               
     .                 xyz_radheatconst(t1+t273-1,t271+t3,k) =                  
     .       1            0.0000000000000000e+000                               
     .                 xyz_radheatconst(t1+t273-1,t271+1+t3,k) =                
     .       1            0.0000000000000000e+000                               
     .                 xyz_radheatconst(t1+t273-1,t271+2+t3,k) =                
     .       1            0.0000000000000000e+000                               
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
     .        go to 10010                                                       
    99        else
   100          xyz_RadHeatConst(:,:,k) = RadHeatRate / DayTime / xyz_ExnerBZ(:,:,k)
     .        if (t24 - t25 + 1 .gt. 0) then                                    
     .           J3 = and(t24 - t25 + 1,3)                                      
     .  !CDIR    NODEP                                                          
     .           do t241 = 1, J3                                                
     .  !CDIR       NODEP                                                       
     .              do t243 = 1, t22 - t23 + 1                                  
     .                 xyz_radheatconst(t1+t243-1,t241-1+t3,k) = radheatrate/   
     .       1            daytime/xyz_exnerbz(t23+t243-1,t241-1+t25,k)          
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t241 = J3 + 1, t24 - t25 + 1, 4                             
     .  !CDIR       NODEP                                                       
     .              do t243 = 1, t22 - t23 + 1                                  
     .                 xyz_radheatconst(t1+t243-1,t241-1+t3,k) = radheatrate/   
     .       1            daytime/xyz_exnerbz(t23+t243-1,t241-1+t25,k)          
     .                 xyz_radheatconst(t1+t243-1,t241+t3,k) = radheatrate/     
     .       1            daytime/xyz_exnerbz(t23+t243-1,t241+t25,k)            
     .                 xyz_radheatconst(t1+t243-1,t241+1+t3,k) = radheatrate/   
     .       1            daytime/xyz_exnerbz(t23+t243-1,t241+1+t25,k)          
     .                 xyz_radheatconst(t1+t243-1,t241+2+t3,k) = radheatrate/   
     .       1            daytime/xyz_exnerbz(t23+t243-1,t241+2+t25,k)          
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   101        end if
   102      end do
   103  
   104      ! ̤Ͷ.
   105      ! ɽ̤ Height1 ǻꤵ줿٤ޤǤδ֤2[K/day](RadHeatRate)
   106      ! ͤѤͿ.
   107      ! Height1  Height2 ޤǤ (Height2 - z_Z(k)) / (Height2 - Height1)
   108      ! γѤθ̤򸺾 (Height2Ǥ礦ɥˤ)
   109      ! Nakajima and Matsuno(1988),(1944)򻲹ͤˤ
   110      !
   111      do k = kmin, kmax
   112        if ( z_Z(k) <= HeightDown ) then
   113          xyz_RadHeatVary(:,:,k) = RadHeatRate / DayTime / xyz_ExnerBZ(:,:,k)
     .        if (t24 - t25 + 1 .gt. 0) then                                    
     .           J4 = and(t24 - t25 + 1,3)                                      
     .  !CDIR    NODEP                                                          
     .           do t263 = 1, J4                                                
     .  !CDIR       NODEP                                                       
     .              do t265 = 1, 2 + t22 - t23 - min0(1,t22 - t23 + 1)          
     .                 xyz_radheatvary(t12+t265-1,t263-1+t14,k) = radheatrate/  
     .       1            daytime/xyz_exnerbz(t23+t265-1,t263-1+t25,k)          
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t263 = J4 + 1, t24 - t25 + 1, 4                             
     .  !CDIR       NODEP                                                       
     .              do t265 = 1, 2 + t22 - t23 - min0(1,t22 - t23 + 1)          
     .                 xyz_radheatvary(t12+t265-1,t263-1+t14,k) = radheatrate/  
     .       1            daytime/xyz_exnerbz(t23+t265-1,t263-1+t25,k)          
     .                 xyz_radheatvary(t12+t265-1,t263+t14,k) = radheatrate/    
     .       1            daytime/xyz_exnerbz(t23+t265-1,t263+t25,k)            
     .                 xyz_radheatvary(t12+t265-1,t263+1+t14,k) = radheatrate/  
     .       1            daytime/xyz_exnerbz(t23+t265-1,t263+1+t25,k)          
     .                 xyz_radheatvary(t12+t265-1,t263+2+t14,k) = radheatrate/  
     .       1            daytime/xyz_exnerbz(t23+t265-1,t263+2+t25,k)          
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
     .        go to 10015                                                       
   114  
   115        elseif ( z_Z(k) > HeightDown .AND. z_Z(k) <= HeightUP) then
   116          xyz_RadHeatVary(:,:,k) =  &
     .        if (t24 - t25 + 1 .gt. 0) then                                    
     .           J5 = and(t24 - t25 + 1,3)                                      
     .  !CDIR    NODEP                                                          
     .           do t255 = 1, J5                                                
     .              D2 = (heightup - z_z(k))/(heightup - heightdown)            
     .  !CDIR       NODEP                                                       
     .              do t257 = 1, 2 + t22 - t23 - min0(1,t22 - t23 + 1)          
     .                 xyz_radheatvary(t12+t257-1,t255-1+t14,k) = radheatrate/  
     .       1            daytime/xyz_exnerbz(t23+t257-1,t255-1+t25,k)*D2       
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t255 = J5 + 1, t24 - t25 + 1, 4                             
     .              D1 = z_z(k)                                                 
     .              D6 = (heightup - D1)/(heightup - heightdown)                
     .              D5 = (heightup - D1)/(heightup - heightdown)                
     .              D4 = (heightup - D1)/(heightup - heightdown)                
     .              D3 = (heightup - D1)/(heightup - heightdown)                
     .  !CDIR       NODEP                                                       
     .              do t257 = 1, 2 + t22 - t23 - min0(1,t22 - t23 + 1)          
     .                 xyz_radheatvary(t12+t257-1,t255-1+t14,k) = radheatrate/  
     .       1            daytime/xyz_exnerbz(t23+t257-1,t255-1+t25,k)*D3       
     .                 xyz_radheatvary(t12+t257-1,t255+t14,k) = radheatrate/    
     .       1            daytime/xyz_exnerbz(t23+t257-1,t255+t25,k)*D4         
     .                 xyz_radheatvary(t12+t257-1,t255+1+t14,k) = radheatrate/  
     .       1            daytime/xyz_exnerbz(t23+t257-1,t255+1+t25,k)*D5       
     .                 xyz_radheatvary(t12+t257-1,t255+2+t14,k) = radheatrate/  
     .       1            daytime/xyz_exnerbz(t23+t257-1,t255+2+t25,k)*D6       
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
     .        go to 10015                                                       
   117            & RadHeatRate / DayTime / xyz_ExnerBZ(:,:,k) &
   118            & * (HeightUP - z_Z(k)) / (HeightUP - HeightDown)
   119  
   120        else if (z_Z(k) > HeightUP) then
   121          xyz_RadHeatVary(:,:,k) = 0.0d0
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t249 = 1, (xyz_radheatvary.DSC.U2 - t14 + 1)*(                 
     .       1   xyz_radheatvary.DSC.U1 - t12 + 1)                              
     .           xyz_radheatvary(t12+t249-1,t14,k) = 0.0000000000000000e+000    
     .        end do                                                            
   122        end if
   123      end do
   124  
   125  
   126      ! Output
   127      !
   128      if (myrank == 0) then
   129        call MessageNotify( "M", &
   130          & "Radiation", "RadHeatRate = %f", d=(/RadHeatRate/))
   131        call MessageNotify( "M", &
   132          & "Radiation", "HeightUp = %f", d=(/HeightUP/))
   133        call MessageNotify( "M", &
   134          & "Radiation", "HeightDown= %f", d=(/HeightDown/))
   135      end if
   136  
   137      call HistoryAutoAddVariable(  &
   138        & varname='PTempRad', &
   139        & dims=(/'x','y','z','t'/),     &
   140        & longname='Radiation term of potential temperature', &
   141        & units='K.s-1"',    &
   142        & xtype='float')
   143  
   144    end subroutine Radiation_Simple_init
   145  
   146  end module Radiation_Simple
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Tue Oct 11 12:34:38 2011
FILE NAME: radiation_simple.f90
PROGRAM NAME: 
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   147  warn (   6): Only comment lines in program.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Tue Oct 11 12:34:38 2011
FILE NAME: radiation_simple.f90
PROGRAM NAME: 
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

   147  
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Tue Oct 11 12:34:38 2011
FILE NAME: radiation_simple.f90
PROGRAM NAME: radiation_simple
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != Module Radiation
     2:            !
     3:            ! Authors::   SUGIYAMA Ko-ichiro
     4:            ! Version::   $Id: radiation_simple.f90,v 1.4 2011-07-15 08:43:29 sugiyama Exp $
     5:            ! Tag Name::  $Name: arare5-20111010 $
     6:            ! Copyright:: Copyright (C) GFD Dennou Club, 2006. All rights reserved.
     7:            ! License::   See COPYRIGHT[link:../../COPYRIGHT]
     8:            !
     9:            !== Overview
    10:            !
    11:            !ǥͲ׻뤿Υѥå⥸塼
    12:            !Ūˤϰʲι׻뤿δؿǼ.  
    13:            !  * 
    14:            !
    15:            !== Error Handling
    16:            !
    17:            !== Bugs
    18:            !
    19:            !== Note
    20:            !
    21:            !
    22:            !== Future Plans
    23:            !
    24:            !
    25:            
    26:            module Radiation_Simple
    27:              !
    28:              !ǥͲ׻뤿Υѥå⥸塼
    29:              !Ūˤϰʲι׻뤿δؿǼ.  
    30:              !  * 
    31:              !
    32:            
    33:              !⥸塼ɤ߹
    34:              use dc_types, only: DP, STRING
    35:              use dc_iounit,  only: FileOpen
    36:              use dc_message, only: MessageNotify
    37:              use gtool_historyauto, only: HistoryAutoAddVariable
    38:            
    39:              use mpi_wrapper,only: myrank
    40:              use gridSet,  only: imin,     & !x β
    41:                &                 imax,     & !x ξ
    42:                &                 jmin,     & !y β
    43:                &                 jmax,     & !y ξ
    44:                &                 kmin,     & !z β
    45:                &                 kmax        !z ξ
    46:              use axesset,  only: z_Z         !Z ɸ(顼ʻ)
    47:              use constants,only: DayTime     ! 1 Ĺ [s]
    48:              use basicset, only: xyz_ExnerBZ !ʡؿδܾ
    49:              use namelist_util, only: namelist_filename
    50:              
    51:              !ۤηػ
    52:              implicit none
    53:            
    54:              !private °
    55:              private
    56:            
    57:              !ѿ
    58:              real(DP), save, allocatable, public :: xyz_RadHeatVary(:,:,:)   !ͲǮ¸ߤΰ
    59:              real(DP), save, allocatable, public :: xyz_RadHeatConst(:,:,:)  !ͲǮ¸ߤΰ
    60:            
    61:              public Radiation_Simple_init
    62:            
    63:            contains
    64:            
    65:            !!!------------------------------------------------------------------------!!!
    66:              subroutine Radiation_Simple_init
    67:                !
    68:                !NAMELIST Ͷ
    69:                !
    70:            
    71:                !ۤηػ
    72:                implicit none
    73:            
    74:                !ѿ
    75:                real(DP)                 :: HeightUp   = 0.0d0  !ͶͿľΰξ
    76:                real(DP)                 :: HeightDown = 0.0d0  !ͶͿľΰβ
    77:                real(DP)                 :: RadHeatRate = 0.0d0   !ͲǮΨ [K/day]
    78:                integer                  :: k                      !롼ѿ
    79:                integer                  :: unit
    80:            
    81:                ! NAMELIST 
    82:                NAMELIST /radiation_simple_nml/ RadHeatRate, HeightUp, HeightDown
    83:            
    84:                call FileOpen(unit, file=namelist_filename, mode='r')
    85:                read(unit, NML=radiation_simple_nml)
    86:                close(unit)
    87:            
    88:                allocate( xyz_RadHeatVary(imin:imax, jmin:jmax, kmin:kmax) )
    89:                allocate( xyz_RadHeatConst(imin:imax, jmin:jmax, kmin:kmax) )
    90:            
    91:                
    92:                ! ̤Ͷ. 
    93:                ! ɽ̤ RadHeight ǻꤵ줿٤ޤǤδ֤ǰѤͿ. 
    94: +------>       do k = kmin, kmax
    95: |                if ( z_Z(k) <= HeightDown  ) then
    96: |+V====            xyz_RadHeatConst(:,:,k) = 0.0d0 
    97: |                elseif( z_Z(k) >= HeightUp ) then
    98: |+V====            xyz_RadHeatConst(:,:,k) = 0.0d0 
    99: |                else
   100: |+V====            xyz_RadHeatConst(:,:,k) = RadHeatRate / DayTime / xyz_ExnerBZ(:,:,k)
   101: |                end if
   102: +------        end do
   103:                
   104:                ! ̤Ͷ.
   105:                ! ɽ̤ Height1 ǻꤵ줿٤ޤǤδ֤2[K/day](RadHeatRate)
   106:                ! ͤѤͿ.
   107:                ! Height1  Height2 ޤǤ (Height2 - z_Z(k)) / (Height2 - Height1)
   108:                ! γѤθ̤򸺾 (Height2Ǥ礦ɥˤ)
   109:                ! Nakajima and Matsuno(1988),(1944)򻲹ͤˤ
   110:                !
   111: +------>       do k = kmin, kmax
   112: |                if ( z_Z(k) <= HeightDown ) then
   113: |+V====            xyz_RadHeatVary(:,:,k) = RadHeatRate / DayTime / xyz_ExnerBZ(:,:,k)
   114: |                  
   115: |                elseif ( z_Z(k) > HeightDown .AND. z_Z(k) <= HeightUP) then
   116: |+V====            xyz_RadHeatVary(:,:,k) =  &
   117: |                    & RadHeatRate / DayTime / xyz_ExnerBZ(:,:,k) &
   118: |                    & * (HeightUP - z_Z(k)) / (HeightUP - HeightDown) 
   119: |                  
   120: |                else if (z_Z(k) > HeightUP) then
   121: |W*====            xyz_RadHeatVary(:,:,k) = 0.0d0
   122: |                end if
   123: +------        end do
   124:                 
   125:            
   126:                ! Output
   127:                !
   128:                if (myrank == 0) then 
   129:                  call MessageNotify( "M", &
   130:                    & "Radiation", "RadHeatRate = %f", d=(/RadHeatRate/))
   131:                  call MessageNotify( "M", &
   132:                    & "Radiation", "HeightUp = %f", d=(/HeightUP/))
   133:                  call MessageNotify( "M", &
   134:                    & "Radiation", "HeightDown= %f", d=(/HeightDown/))
   135:                end if
   136:                
   137:                call HistoryAutoAddVariable(  &
   138:                  & varname='PTempRad', &
   139:                  & dims=(/'x','y','z','t'/),     &
   140:                  & longname='Radiation term of potential temperature', &
   141:                  & units='K.s-1"',    &
   142:                  & xtype='float')
   143:            
   144:              end subroutine Radiation_Simple_init
   145:            
   146:            end module Radiation_Simple
